diff --git a/sys/netproto/atm/uni/unisig_sigmgr_state.c b/sys/netproto/atm/uni/unisig_sigmgr_state.c
index ece9eab..d578058 100644
--- a/sys/netproto/atm/uni/unisig_sigmgr_state.c
+++ b/sys/netproto/atm/uni/unisig_sigmgr_state.c
@@ -395,9 +395,7 @@ unisig_sigmgr_act04(struct unisig *usp, KBuffer *m)
 	/*
 	 * Try to establish an SSCF session.
 	 */
-	err = atm_cm_saal_ctl(SSCF_UNI_ESTABLISH_REQ,
-			usp->us_conn,
-			(void *)0);
+	err = atm_cm_saal_ctl(SSCF_UNI_ESTABLISH_REQ, usp->us_conn, NULL);
 	if (err)
 		panic("unisig_sigmgr_act04: SSCF_UNI_ESTABLISH_REQ");
 
@@ -708,9 +706,7 @@ unisig_sigmgr_act13(struct unisig *usp, KBuffer *m)
 	/*
 	 * Establish the SSCF session
 	 */
-	err = atm_cm_saal_ctl(SSCF_UNI_ESTABLISH_REQ,
-			usp->us_conn,
-			(void *)0);
+	err = atm_cm_saal_ctl(SSCF_UNI_ESTABLISH_REQ, usp->us_conn, NULL);
 	if (err)
 		panic("unisig_sigmgr_act13: SSCF_UNI_ESTABLISH_REQ");
 
@@ -748,7 +744,7 @@ unisig_sigmgr_act14(struct unisig *usp, KBuffer *m)
 	/*
 	 * Locate the signalling channel's VCCB
 	 */
-	sig_vccb = (struct unisig_vccb *)0;
+	sig_vccb = NULL;
 	if (usp->us_conn && usp->us_conn->co_connvc)
 		sig_vccb = (struct unisig_vccb *)
 				usp->us_conn->co_connvc->cvc_vcc;
diff --git a/sys/netproto/atm/uni/unisig_vc_state.c b/sys/netproto/atm/uni/unisig_vc_state.c
index 5dc108e..a6b33e9 100644
--- a/sys/netproto/atm/uni/unisig_vc_state.c
+++ b/sys/netproto/atm/uni/unisig_vc_state.c
@@ -1274,8 +1274,7 @@ unisig_vc_act14(struct unisig *usp, struct unisig_vccb *uvp,
 		/*
 		 * Resend the RELEASE message
 		 */
-		rc = unisig_send_release(usp, uvp,
-				(struct unisig_msg *)0, T_ATM_ABSENT);
+		rc = unisig_send_release(usp, uvp, NULL, T_ATM_ABSENT);
 		if (rc)
 			return(rc);
 
diff --git a/sys/netproto/ncp/ncp_sock.c b/sys/netproto/ncp/ncp_sock.c
index d024384..5a39892 100644
--- a/sys/netproto/ncp/ncp_sock.c
+++ b/sys/netproto/ncp/ncp_sock.c
@@ -366,13 +366,13 @@ ncp_sock_disconnect(struct ncp_conn *conn) {
 	conn->flags &= ~(NCPFL_SOCONN | NCPFL_ATTACHED | NCPFL_LOGGED);
 	if (conn->ncp_so) {
 		so = conn->ncp_so;
-		conn->ncp_so = (struct socket *)0;
+		conn->ncp_so = NULL;
 		soshutdown(so, SHUT_RDWR);
 		soclose(so, FNONBLOCK);
 	}
 	if (conn->wdg_so) {
 		so = conn->wdg_so;
-		conn->wdg_so = (struct socket *)0;
+		conn->wdg_so = NULL;
 		soshutdown(so, SHUT_RDWR);
 		soclose(so, FNONBLOCK);
 	}
diff --git a/sys/netproto/ns/idp_usrreq.c b/sys/netproto/ns/idp_usrreq.c
index c5f4d69..14ffeb1 100644
--- a/sys/netproto/ns/idp_usrreq.c
+++ b/sys/netproto/ns/idp_usrreq.c
@@ -110,7 +110,7 @@ idp_input(struct mbuf *m, ...)
 		m->m_data += sizeof (struct idp);
 	}
 	if (ssb_appendaddr(&nsp->nsp_socket->so_rcv, (struct sockaddr *)&idp_ns,
-	    m, (struct mbuf *)0) == 0)
+	    m, NULL) == 0)
 		goto bad;
 	sorwakeup(nsp->nsp_socket);
 	return;
@@ -223,7 +223,7 @@ idp_output(struct mbuf *m0, struct socket *so, ...)
 	 * Output datagram.
 	 */
 	if (so->so_options & SO_DONTROUTE)
-		return (ns_output(m, (struct route *)0,
+		return (ns_output(m, NULL,
 		    (so->so_options & SO_BROADCAST) | NS_ROUTETOIF));
 	/*
 	 * Use cached route for previous datagram if
@@ -262,7 +262,7 @@ idp_output(struct mbuf *m0, struct socket *so, ...)
 		} else {
 		re_route:
 			RTFREE(ro->ro_rt);
-			ro->ro_rt = (struct rtentry *)0;
+			ro->ro_rt = NULL;
 		}
 	}
 	nsp->nsp_lastdst = idp->idp_dna;
diff --git a/sys/netproto/ns/ns.c b/sys/netproto/ns/ns.c
index 182d796..17e0aab 100644
--- a/sys/netproto/ns/ns.c
+++ b/sys/netproto/ns/ns.c
@@ -88,14 +88,14 @@ ns_control(struct socket *so, u_long cmd, caddr_t data, struct ifnet *ifp,
 	switch (cmd) {
 
 	case SIOCGIFADDR:
-		if (ia == (struct ns_ifaddr *)0)
+		if (ia == NULL)
 			return (EADDRNOTAVAIL);
 		*(struct sockaddr_ns *)&ifr->ifr_addr = ia->ia_addr;
 		return (0);
 
 
 	case SIOCGIFBRDADDR:
-		if (ia == (struct ns_ifaddr *)0)
+		if (ia == NULL)
 			return (EADDRNOTAVAIL);
 		if ((ifp->if_flags & IFF_BROADCAST) == 0)
 			return (EINVAL);
@@ -103,7 +103,7 @@ ns_control(struct socket *so, u_long cmd, caddr_t data, struct ifnet *ifp,
 		return (0);
 
 	case SIOCGIFDSTADDR:
-		if (ia == (struct ns_ifaddr *)0)
+		if (ia == NULL)
 			return (EADDRNOTAVAIL);
 		if ((ifp->if_flags & IFF_POINTOPOINT) == 0)
 			return (EINVAL);
@@ -132,7 +132,7 @@ ns_control(struct socket *so, u_long cmd, caddr_t data, struct ifnet *ifp,
 
 	case SIOCSIFADDR:
 	case SIOCSIFDSTADDR:
-		if (ia == (struct ns_ifaddr *)0) {
+		if (ia == NULL) {
 			oia = ifa_create(sizeof(*ia), M_WAITOK);
 			if ((ia = ns_ifaddr) != NULL) {
 				for ( ; ia->ia_next; ia = ia->ia_next)
diff --git a/sys/netproto/ns/ns_error.c b/sys/netproto/ns/ns_error.c
index a190d66..286687f 100644
--- a/sys/netproto/ns/ns_error.c
+++ b/sys/netproto/ns/ns_error.c
@@ -165,7 +165,7 @@ ns_error(struct mbuf *om, int type, int param)
 		nip->idp_sum = ns_cksum(m, sizeof(*ep));
 	} else
 		nip->idp_sum = 0xffff;
-	ns_output(m, (struct route *)0, 0);
+	ns_output(m, NULL, 0);
 
 freeit:
 	m_freem(om);
@@ -314,6 +314,6 @@ ns_echo(struct mbuf *m)
 		idp->idp_sum = ns_cksum(m,
 		    (int)(((ntohs(idp->idp_len) - 1)|1)+1));
 	}
-	ns_output(m, (struct route *)0, NS_FORWARDING);
+	ns_output(m, NULL, NS_FORWARDING);
 	return(0);
 }
diff --git a/sys/netproto/ns/ns_ip.c b/sys/netproto/ns/ns_ip.c
index 440426f..852f94f 100644
--- a/sys/netproto/ns/ns_ip.c
+++ b/sys/netproto/ns/ns_ip.c
@@ -284,7 +284,7 @@ nsipoutput_serialized(struct ifnet_en *ifn, struct mbuf *m,
 	/*
 	 * Output final datagram.
 	 */
-	error =  (ip_output(m, (struct mbuf *)0, ro, SO_BROADCAST, NULL));
+	error =  (ip_output(m, NULL, ro, SO_BROADCAST, NULL));
 	if (error) {
 		ifn->ifen_ifnet.if_oerrors++;
 		ifn->ifen_ifnet.if_ierrors = error;
@@ -383,10 +383,10 @@ nsip_route(struct mbuf *m)
 	 */
 	ifr.ifr_name[4] = '0' + nsipif_units - 1;
 	ifr.ifr_dstaddr = * (struct sockaddr *) ns_dst;
-	ns_control((struct socket *)0, (int)SIOCSIFDSTADDR, (caddr_t)&ifr,
+	ns_control(NULL, (int)SIOCSIFDSTADDR, (caddr_t)&ifr,
 			(struct ifnet *)ifn, NULL);
 	satons_addr(ifr.ifr_addr).x_host = ns_thishost;
-	return (ns_control((struct socket *)0, (int)SIOCSIFADDR, (caddr_t)&ifr,
+	return (ns_control(NULL, (int)SIOCSIFADDR, (caddr_t)&ifr,
 			(struct ifnet *)ifn, NULL));
 }
 
diff --git a/sys/netproto/ns/ns_pcb.c b/sys/netproto/ns/ns_pcb.c
index f4fca20..e7c650b 100644
--- a/sys/netproto/ns/ns_pcb.c
+++ b/sys/netproto/ns/ns_pcb.c
@@ -164,14 +164,14 @@ ns_pcbconnect(struct nspcb *nsp, struct sockaddr *nam)
 	flush:
 			if (ro->ro_rt)
 				RTFREE(ro->ro_rt);
-			ro->ro_rt = (struct rtentry *)0;
+			ro->ro_rt = NULL;
 			nsp->nsp_laddr.x_net = ns_zeronet;
 		}
 	}/* else cached route is ok; do nothing */
 	nsp->nsp_lastdst = sns->sns_addr;
 	if ((nsp->nsp_socket->so_options & SO_DONTROUTE) == 0 && /*XXX*/
-	    (ro->ro_rt == (struct rtentry *)0 ||
-	     ro->ro_rt->rt_ifp == (struct ifnet *)0)) {
+	    (ro->ro_rt == NULL ||
+	     ro->ro_rt->rt_ifp == NULL)) {
 		    /* No route yet, so try to acquire one */
 		    ro->ro_dst.sa_family = AF_NS;
 		    ro->ro_dst.sa_len = sizeof(ro->ro_dst);
@@ -185,7 +185,7 @@ ns_pcbconnect(struct nspcb *nsp, struct sockaddr *nam)
 		 * our src addr is taken from the i/f, else punt.
 		 */
 
-		ia = (struct ns_ifaddr *)0;
+		ia = NULL;
 		/*
 		 * If we found a route, use the address
 		 * corresponding to the outgoing interface
diff --git a/sys/netproto/ns/spp_usrreq.c b/sys/netproto/ns/spp_usrreq.c
index 2b2e5a1..5539cd8 100644
--- a/sys/netproto/ns/spp_usrreq.c
+++ b/sys/netproto/ns/spp_usrreq.c
@@ -276,7 +276,7 @@ spp_input(struct mbuf *m, ...)
 		m_freem(m);
 	}
 	if (cb->s_force || (cb->s_flags & (SF_ACKNOW|SF_WIN|SF_RXT)))
-		spp_output(cb, (struct mbuf *)0);
+		spp_output(cb, NULL);
 	cb->s_flags &= ~(SF_WIN|SF_RXT);
 	return;
 
@@ -345,7 +345,7 @@ spp_reass(struct sppcb *cb, struct spidp *si, struct mbuf *si_m)
 				cb->s_snxt = si->si_ack;
 				cb->s_cwnd = CUNIT;
 				cb->s_force = 1 + SPPT_REXMT;
-				spp_output(cb, (struct mbuf *)0);
+				spp_output(cb, NULL);
 				cb->s_timer[SPPT_REXMT] = cb->s_rxtcur;
 				cb->s_rtt = 0;
 				if (cwnd >= 4 * CUNIT)
@@ -1106,7 +1106,7 @@ send:
 			spp_trace(SA_OUTPUT, cb->s_state, cb, si, 0);
 
 		if (so->so_options & SO_DONTROUTE)
-			error = ns_output(m, (struct route *)0, NS_ROUTETOIF);
+			error = ns_output(m, NULL, NS_ROUTETOIF);
 		else
 			error = ns_output(m, &cb->s_nspcb->nsp_route, 0);
 	}
@@ -1725,7 +1725,7 @@ spp_close(struct sppcb *cb)
 	soisdisconnected(so);
 	ns_pcbdetach(nsp);
 	sppstat.spps_closed++;
-	return ((struct sppcb *)0);
+	return (NULL);
 }
 /*
  *	Someday we may do level 3 handshaking
diff --git a/sys/platform/pc32/i386/db_trace.c b/sys/platform/pc32/i386/db_trace.c
index 7f5c367..355be8a 100644
--- a/sys/platform/pc32/i386/db_trace.c
+++ b/sys/platform/pc32/i386/db_trace.c
@@ -62,22 +62,22 @@ db_varfcn_t db_dr7;
  * Machine register set.
  */
 struct db_variable db_regs[] = {
-	{ "cs",		&ddb_regs.tf_cs,     FCN_NULL },
-	{ "ds",		&ddb_regs.tf_ds,     FCN_NULL },
-	{ "es",		&ddb_regs.tf_es,     FCN_NULL },
-	{ "fs",		&ddb_regs.tf_fs,     FCN_NULL },
-	{ "gs",		&ddb_regs.tf_gs,     FCN_NULL },
-	{ "ss",		&ddb_regs.tf_ss,     FCN_NULL },
-	{ "eax",	&ddb_regs.tf_eax,    FCN_NULL },
-	{ "ecx",	&ddb_regs.tf_ecx,    FCN_NULL },
-	{ "edx",	&ddb_regs.tf_edx,    FCN_NULL },
-	{ "ebx",	&ddb_regs.tf_ebx,    FCN_NULL },
-	{ "esp",	&ddb_regs.tf_esp,    FCN_NULL },
-	{ "ebp",	&ddb_regs.tf_ebp,    FCN_NULL },
-	{ "esi",	&ddb_regs.tf_esi,    FCN_NULL },
-	{ "edi",	&ddb_regs.tf_edi,    FCN_NULL },
-	{ "eip",	&ddb_regs.tf_eip,    FCN_NULL },
-	{ "efl",	&ddb_regs.tf_eflags, FCN_NULL },
+	{ "cs",		&ddb_regs.tf_cs,     NULL },
+	{ "ds",		&ddb_regs.tf_ds,     NULL },
+	{ "es",		&ddb_regs.tf_es,     NULL },
+	{ "fs",		&ddb_regs.tf_fs,     NULL },
+	{ "gs",		&ddb_regs.tf_gs,     NULL },
+	{ "ss",		&ddb_regs.tf_ss,     NULL },
+	{ "eax",	&ddb_regs.tf_eax,    NULL },
+	{ "ecx",	&ddb_regs.tf_ecx,    NULL },
+	{ "edx",	&ddb_regs.tf_edx,    NULL },
+	{ "ebx",	&ddb_regs.tf_ebx,    NULL },
+	{ "esp",	&ddb_regs.tf_esp,    NULL },
+	{ "ebp",	&ddb_regs.tf_ebp,    NULL },
+	{ "esi",	&ddb_regs.tf_esi,    NULL },
+	{ "edi",	&ddb_regs.tf_edi,    NULL },
+	{ "eip",	&ddb_regs.tf_eip,    NULL },
+	{ "efl",	&ddb_regs.tf_eflags, NULL },
 	{ "dr0",	NULL,		     db_dr0 },
 	{ "dr1",	NULL,		     db_dr1 },
 	{ "dr2",	NULL,		     db_dr2 },
diff --git a/sys/platform/pc64/amd64/db_trace.c b/sys/platform/pc64/amd64/db_trace.c
index 2c38d71..bf02be1 100644
--- a/sys/platform/pc64/amd64/db_trace.c
+++ b/sys/platform/pc64/amd64/db_trace.c
@@ -94,30 +94,30 @@ db_varfcn_t db_dr7;
  * Machine register set.
  */
 struct db_variable db_regs[] = {
-	{ "cs",		&ddb_regs.tf_cs,     FCN_NULL },
-/*	{ "ds",		&ddb_regs.tf_ds,     FCN_NULL },
-	{ "es",		&ddb_regs.tf_es,     FCN_NULL },
-	{ "fs",		&ddb_regs.tf_fs,     FCN_NULL },
-	{ "gs",		&ddb_regs.tf_gs,     FCN_NULL }, */
-	{ "ss",		&ddb_regs.tf_ss,     FCN_NULL },
-	{ "rax",	&ddb_regs.tf_rax,    FCN_NULL },
-	{ "rcx",	&ddb_regs.tf_rcx,    FCN_NULL },
-	{ "rdx",	&ddb_regs.tf_rdx,    FCN_NULL },
-	{ "rbx",	&ddb_regs.tf_rbx,    FCN_NULL },
-	{ "rsp",	&ddb_regs.tf_rsp,    FCN_NULL },
-	{ "rbp",	&ddb_regs.tf_rbp,    FCN_NULL },
-	{ "rsi",	&ddb_regs.tf_rsi,    FCN_NULL },
-	{ "rdi",	&ddb_regs.tf_rdi,    FCN_NULL },
-	{ "rip",	&ddb_regs.tf_rip,    FCN_NULL },
-	{ "rfl",	&ddb_regs.tf_rflags, FCN_NULL },
-	{ "r8",		&ddb_regs.tf_r8,     FCN_NULL },
-	{ "r9",		&ddb_regs.tf_r9,     FCN_NULL },
-	{ "r10",	&ddb_regs.tf_r10,    FCN_NULL },
-	{ "r11",	&ddb_regs.tf_r11,    FCN_NULL },
-	{ "r12",	&ddb_regs.tf_r12,    FCN_NULL },
-	{ "r13",	&ddb_regs.tf_r13,    FCN_NULL },
-	{ "r14",	&ddb_regs.tf_r14,    FCN_NULL },
-	{ "r15",	&ddb_regs.tf_r15,    FCN_NULL },
+	{ "cs",		&ddb_regs.tf_cs,     NULL },
+/*	{ "ds",		&ddb_regs.tf_ds,     NULL },
+	{ "es",		&ddb_regs.tf_es,     NULL },
+	{ "fs",		&ddb_regs.tf_fs,     NULL },
+	{ "gs",		&ddb_regs.tf_gs,     NULL }, */
+	{ "ss",		&ddb_regs.tf_ss,     NULL },
+	{ "rax",	&ddb_regs.tf_rax,    NULL },
+	{ "rcx",	&ddb_regs.tf_rcx,    NULL },
+	{ "rdx",	&ddb_regs.tf_rdx,    NULL },
+	{ "rbx",	&ddb_regs.tf_rbx,    NULL },
+	{ "rsp",	&ddb_regs.tf_rsp,    NULL },
+	{ "rbp",	&ddb_regs.tf_rbp,    NULL },
+	{ "rsi",	&ddb_regs.tf_rsi,    NULL },
+	{ "rdi",	&ddb_regs.tf_rdi,    NULL },
+	{ "rip",	&ddb_regs.tf_rip,    NULL },
+	{ "rfl",	&ddb_regs.tf_rflags, NULL },
+	{ "r8",		&ddb_regs.tf_r8,     NULL },
+	{ "r9",		&ddb_regs.tf_r9,     NULL },
+	{ "r10",	&ddb_regs.tf_r10,    NULL },
+	{ "r11",	&ddb_regs.tf_r11,    NULL },
+	{ "r12",	&ddb_regs.tf_r12,    NULL },
+	{ "r13",	&ddb_regs.tf_r13,    NULL },
+	{ "r14",	&ddb_regs.tf_r14,    NULL },
+	{ "r15",	&ddb_regs.tf_r15,    NULL },
 	{ "dr0",	NULL,		     db_dr0 },
 	{ "dr1",	NULL,		     db_dr1 },
 	{ "dr2",	NULL,		     db_dr2 },
diff --git a/sys/platform/vkernel/i386/db_trace.c b/sys/platform/vkernel/i386/db_trace.c
index 706a43e..5dab6bd 100644
--- a/sys/platform/vkernel/i386/db_trace.c
+++ b/sys/platform/vkernel/i386/db_trace.c
@@ -56,22 +56,22 @@ static int db_dr(struct db_variable *vp, db_expr_t *valuep, int op);
  * Machine register set.
  */
 struct db_variable db_regs[] = {
-	{ "cs",		&ddb_regs.tf_cs,     FCN_NULL },
-	{ "ds",		&ddb_regs.tf_ds,     FCN_NULL },
-	{ "es",		&ddb_regs.tf_es,     FCN_NULL },
-	{ "fs",		&ddb_regs.tf_fs,     FCN_NULL },
-	{ "gs",		&ddb_regs.tf_gs,     FCN_NULL },
-	{ "ss",		&ddb_regs.tf_ss,     FCN_NULL },
-	{ "eax",	&ddb_regs.tf_eax,    FCN_NULL },
-	{ "ecx",	&ddb_regs.tf_ecx,    FCN_NULL },
-	{ "edx",	&ddb_regs.tf_edx,    FCN_NULL },
-	{ "ebx",	&ddb_regs.tf_ebx,    FCN_NULL },
-	{ "esp",	&ddb_regs.tf_esp,    FCN_NULL },
-	{ "ebp",	&ddb_regs.tf_ebp,    FCN_NULL },
-	{ "esi",	&ddb_regs.tf_esi,    FCN_NULL },
-	{ "edi",	&ddb_regs.tf_edi,    FCN_NULL },
-	{ "eip",	&ddb_regs.tf_eip,    FCN_NULL },
-	{ "efl",	&ddb_regs.tf_eflags, FCN_NULL },
+	{ "cs",		&ddb_regs.tf_cs,     NULL },
+	{ "ds",		&ddb_regs.tf_ds,     NULL },
+	{ "es",		&ddb_regs.tf_es,     NULL },
+	{ "fs",		&ddb_regs.tf_fs,     NULL },
+	{ "gs",		&ddb_regs.tf_gs,     NULL },
+	{ "ss",		&ddb_regs.tf_ss,     NULL },
+	{ "eax",	&ddb_regs.tf_eax,    NULL },
+	{ "ecx",	&ddb_regs.tf_ecx,    NULL },
+	{ "edx",	&ddb_regs.tf_edx,    NULL },
+	{ "ebx",	&ddb_regs.tf_ebx,    NULL },
+	{ "esp",	&ddb_regs.tf_esp,    NULL },
+	{ "ebp",	&ddb_regs.tf_ebp,    NULL },
+	{ "esi",	&ddb_regs.tf_esi,    NULL },
+	{ "edi",	&ddb_regs.tf_edi,    NULL },
+	{ "eip",	&ddb_regs.tf_eip,    NULL },
+	{ "efl",	&ddb_regs.tf_eflags, NULL },
 	{ "dr0",	NULL,		     db_dr },
 	{ "dr1",	NULL,		     db_dr },
 	{ "dr2",	NULL,		     db_dr },
diff --git a/sys/sys/semaphore.h b/sys/sys/semaphore.h
index c80ad39..580f229 100644
--- a/sys/sys/semaphore.h
+++ b/sys/sys/semaphore.h
@@ -50,7 +50,7 @@
 struct sem;
 typedef struct sem *sem_t;
 
-#define SEM_FAILED	((sem_t *)0)
+#define SEM_FAILED	(NULL)
 #define SEM_VALUE_MAX	UINT_MAX
 
 #ifndef _KERNEL
diff --git a/sys/vfs/fifofs/fifo_vnops.c b/sys/vfs/fifofs/fifo_vnops.c
index ef8392c..7b16737 100644
--- a/sys/vfs/fifofs/fifo_vnops.c
+++ b/sys/vfs/fifofs/fifo_vnops.c
@@ -318,8 +318,7 @@ fifo_write(struct vop_write_args *ap)
 	else
 		flags = 0;
 	vn_unlock(ap->a_vp);
-	error = sosend(wso, (struct sockaddr *)0, ap->a_uio, 0,
-		       (struct mbuf *)0, flags, td);
+	error = sosend(wso, NULL, ap->a_uio, 0, NULL, flags, td);
 	vn_lock(ap->a_vp, LK_EXCLUSIVE | LK_RETRY);
 	return (error);
 }
diff --git a/sys/vfs/gnu/ext2fs/ext2_balloc.c b/sys/vfs/gnu/ext2fs/ext2_balloc.c
index 28b8c5b..66f37a7 100644
--- a/sys/vfs/gnu/ext2fs/ext2_balloc.c
+++ b/sys/vfs/gnu/ext2fs/ext2_balloc.c
@@ -170,7 +170,7 @@ ext2_debug("ext2_balloc called (%d, %d, %d)\n",
 	nb = ip->i_ib[indirs[0].in_off];
 	if (nb == 0) {
 #if 0
-		pref = ext2_blkpref(ip, lbn, 0, (daddr_t *)0, 0);
+		pref = ext2_blkpref(ip, lbn, 0, NULL, 0);
 #else
 		/* see the comment by ext2_blkpref. What we do here is
 		   to pretend that it'd be good for a block holding indirect
@@ -236,7 +236,7 @@ ext2_debug("ext2_balloc called (%d, %d, %d)\n",
 			pref = ext2_blkpref(ip, lbn, indirs[i].in_off, bap,
 						lblkno(fs, bp->b_loffset));
 #else
-			pref = ext2_blkpref(ip, lbn, 0, (daddr_t *)0, 0);
+			pref = ext2_blkpref(ip, lbn, 0, NULL, 0);
 #endif
 		if ((error =
 		    ext2_alloc(ip, lbn, pref, (int)fs->s_blocksize, cred, &newb)) != 0) {
diff --git a/sys/vfs/gnu/ext2fs/ext2_lookup.c b/sys/vfs/gnu/ext2fs/ext2_lookup.c
index 7f3862d..8f081d4 100644
--- a/sys/vfs/gnu/ext2fs/ext2_lookup.c
+++ b/sys/vfs/gnu/ext2fs/ext2_lookup.c
@@ -1015,7 +1015,7 @@ ext2_checkpath(struct inode *source, struct inode *target, struct ucred *cred)
 		}
 		error = vn_rdwr(UIO_READ, vp, (caddr_t)&dirbuf,
 				sizeof (struct dirtemplate), (off_t)0,
-				UIO_SYSSPACE, IO_NODELOCKED, cred, (int *)0);
+				UIO_SYSSPACE, IO_NODELOCKED, cred, NULL);
 		if (error != 0)
 			break;
 		namlen = dirbuf.dotdot_type;	/* like ufs little-endian */
diff --git a/sys/vfs/gnu/ext2fs/ext2_quota.c b/sys/vfs/gnu/ext2fs/ext2_quota.c
index d0a4c74..46432d7 100644
--- a/sys/vfs/gnu/ext2fs/ext2_quota.c
+++ b/sys/vfs/gnu/ext2fs/ext2_quota.c
@@ -918,7 +918,7 @@ ext2_dqflush(struct vnode *vp)
 			if (dq->dq_cnt)
 				panic("dqflush: stray dquot");
 			LIST_REMOVE(dq, dq_hash);
-			dq->dq_ump = (struct ext2mount *)0;
+			dq->dq_ump = NULL;
 		}
 	}
 }
diff --git a/sys/vfs/gnu/ext2fs/ext2_vnops.c b/sys/vfs/gnu/ext2fs/ext2_vnops.c
index 8f07518..7bf177e 100644
--- a/sys/vfs/gnu/ext2fs/ext2_vnops.c
+++ b/sys/vfs/gnu/ext2fs/ext2_vnops.c
@@ -790,7 +790,7 @@ abortit:
 			error = vn_rdwr(UIO_READ, fvp, (caddr_t)&dirbuf,
 					sizeof (struct dirtemplate), (off_t)0,
 					UIO_SYSSPACE, IO_NODELOCKED,
-					tcnp->cn_cred, (int *)0);
+					tcnp->cn_cred, NULL);
 			if (error == 0) {
 				/* Like ext2 little-endian: */
 				namlen = dirbuf.dotdot_type;
@@ -806,7 +806,7 @@ abortit:
 						sizeof (struct dirtemplate),
 						(off_t)0, UIO_SYSSPACE,
 						IO_NODELOCKED|IO_SYNC,
-						tcnp->cn_cred, (int *)0);
+						tcnp->cn_cred, NULL);
 				}
 			}
 		}
@@ -975,7 +975,7 @@ ext2_mkdir(struct vop_old_mkdir_args *ap)
 	dirtemplate.dotdot_reclen = DIRBLKSIZ - 12;
 	error = vn_rdwr(UIO_WRITE, tvp, (caddr_t)&dirtemplate,
 			sizeof (dirtemplate), (off_t)0, UIO_SYSSPACE,
-			IO_NODELOCKED|IO_SYNC, cnp->cn_cred, (int *)0);
+			IO_NODELOCKED|IO_SYNC, cnp->cn_cred, NULL);
 	if (error) {
 		dp->i_nlink--;
 		dp->i_flag |= IN_CHANGE;
@@ -1110,7 +1110,7 @@ ext2_symlink(struct vop_old_symlink_args *ap)
 
 		error = vn_rdwr(UIO_WRITE, vp, ap->a_target, len, (off_t)0,
 				UIO_SYSSPACE, IO_NODELOCKED, 
-				ap->a_cnp->cn_cred, (int *)0);
+				ap->a_cnp->cn_cred, NULL);
 
 		if (error)
 			vput(vp);
diff --git a/sys/vfs/isofs/cd9660/cd9660_vfsops.c b/sys/vfs/isofs/cd9660/cd9660_vfsops.c
index ebd8097..c38e038 100644
--- a/sys/vfs/isofs/cd9660/cd9660_vfsops.c
+++ b/sys/vfs/isofs/cd9660/cd9660_vfsops.c
@@ -682,7 +682,7 @@ cd9660_vget(struct mount *mp, ino_t ino, struct vnode **vpp)
 #else
 	    0,
 #endif
-	    (struct iso_directory_record *)0));
+	    NULL));
 }
 
 int
diff --git a/sys/vfs/msdosfs/msdosfs_vnops.c b/sys/vfs/msdosfs/msdosfs_vnops.c
index bb660ce..045d742 100644
--- a/sys/vfs/msdosfs/msdosfs_vnops.c
+++ b/sys/vfs/msdosfs/msdosfs_vnops.c
@@ -1246,7 +1246,7 @@ abortit:
 		bcopy(toname, ip->de_Name, 11);	/* update denode */
 		dp->de_fndoffset = to_diroffset;
 		dp->de_fndcnt = to_count;
-		error = createde(ip, dp, (struct denode **)0, tcnp);
+		error = createde(ip, dp, NULL, tcnp);
 		if (error) {
 			bcopy(oldname, ip->de_Name, 11);
 			goto done;
diff --git a/sys/vfs/nfs/nfs_bio.c b/sys/vfs/nfs/nfs_bio.c
index 388396d..0799ac6 100644
--- a/sys/vfs/nfs/nfs_bio.c
+++ b/sys/vfs/nfs/nfs_bio.c
@@ -1103,7 +1103,7 @@ nfs_getcacheblk(struct vnode *vp, off_t loffset, int size, struct thread *td)
 	if (nmp->nm_flag & NFSMNT_INT) {
 		bp = getblk(vp, loffset, size, GETBLK_PCATCH, 0);
 		while (bp == NULL) {
-			if (nfs_sigintr(nmp, (struct nfsreq *)0, td))
+			if (nfs_sigintr(nmp, NULL, td))
 				return (NULL);
 			bp = getblk(vp, loffset, size, 0, 2 * hz);
 		}
diff --git a/sys/vfs/nfs/nfs_serv.c b/sys/vfs/nfs/nfs_serv.c
index c56cc07..4b2f1df 100644
--- a/sys/vfs/nfs/nfs_serv.c
+++ b/sys/vfs/nfs/nfs_serv.c
@@ -179,7 +179,7 @@ nfsrv3_access(struct nfsrv_descript *nfsd, struct nfssvc_sock *slp,
 	    (nfsd->nd_flag & ND_KERBAUTH), TRUE);
 	if (error) {
 		nfsm_reply(NFSX_UNSIGNED);
-		nfsm_srvpostop_attr(1, (struct vattr *)0);
+		nfsm_srvpostop_attr(1, NULL);
 		error = 0;
 		goto nfsmout;
 	}
@@ -627,7 +627,7 @@ nfsrv_readlink(struct nfsrv_descript *nfsd, struct nfssvc_sock *slp,
 
 	nfsdbprintf(("%s %d\n", __FILE__, __LINE__));
 #ifndef nolint
-	mp2 = (struct mbuf *)0;
+	mp2 = NULL;
 #endif
 	mp3 = NULL;
 	fhp = &nfh.fh_generic;
@@ -664,7 +664,7 @@ nfsrv_readlink(struct nfsrv_descript *nfsd, struct nfssvc_sock *slp,
 		 &rdonly, (nfsd->nd_flag & ND_KERBAUTH), TRUE);
 	if (error) {
 		nfsm_reply(2 * NFSX_UNSIGNED);
-		nfsm_srvpostop_attr(1, (struct vattr *)0);
+		nfsm_srvpostop_attr(1, NULL);
 		error = 0;
 		goto nfsmout;
 	}
@@ -762,7 +762,7 @@ nfsrv_read(struct nfsrv_descript *nfsd, struct nfssvc_sock *slp,
 	if (error) {
 		vp = NULL;
 		nfsm_reply(2 * NFSX_UNSIGNED);
-		nfsm_srvpostop_attr(1, (struct vattr *)0);
+		nfsm_srvpostop_attr(1, NULL);
 		error = 0;
 		goto nfsmout;
 	}
@@ -2072,7 +2072,7 @@ nfsrv_rename(struct nfsrv_descript *nfsd, struct nfssvc_sock *slp,
 
 	nfsdbprintf(("%s %d\n", __FILE__, __LINE__));
 #ifndef nolint
-	fvp = (struct vnode *)0;
+	fvp = NULL;
 #endif
 	ffhp = &fnfh.fh_generic;
 	tfhp = &tnfh.fh_generic;
@@ -2396,7 +2396,7 @@ nfsrv_symlink(struct nfsrv_descript *nfsd, struct nfssvc_sock *slp,
 	u_int32_t *tl;
 	int32_t t1;
 	struct nfsv2_sattr *sp;
-	char *bpos, *pathcp = (char *)0, *cp2;
+	char *bpos, *pathcp = NULL, *cp2;
 	struct uio io;
 	struct iovec iv;
 	int error = 0, len, len2, dirfor_ret = 1, diraft_ret = 1;
diff --git a/sys/vfs/nfs/nfs_socket.c b/sys/vfs/nfs/nfs_socket.c
index f0b09ae..1b620c7 100644
--- a/sys/vfs/nfs/nfs_socket.c
+++ b/sys/vfs/nfs/nfs_socket.c
@@ -212,7 +212,7 @@ nfs_connect(struct nfsmount *nmp, struct nfsreq *rep)
 	struct sockaddr_in *sin;
 	struct thread *td = &thread0; /* only used for socreate and sobind */
 
-	nmp->nm_so = (struct socket *)0;
+	nmp->nm_so = NULL;
 	saddr = nmp->nm_nam;
 	error = socreate(saddr->sa_family, &nmp->nm_so, nmp->nm_sotype,
 		nmp->nm_soproto, td);
@@ -420,7 +420,7 @@ nfs_disconnect(struct nfsmount *nmp)
 
 	if (nmp->nm_so) {
 		so = nmp->nm_so;
-		nmp->nm_so = (struct socket *)0;
+		nmp->nm_so = NULL;
 		soshutdown(so, SHUT_RDWR);
 		soclose(so, FNONBLOCK);
 	}
@@ -474,7 +474,7 @@ nfs_send(struct socket *so, struct sockaddr *nam, struct mbuf *top,
 	} else
 		soflags = so->so_proto->pr_flags;
 	if ((soflags & PR_CONNREQUIRED) || (so->so_state & SS_ISCONNECTED))
-		sendnam = (struct sockaddr *)0;
+		sendnam = NULL;
 	else
 		sendnam = nam;
 	if (so->so_type == SOCK_SEQPACKET)
@@ -980,7 +980,7 @@ nfs_request(struct vnode *vp, struct mbuf *mrest, int procnum,
 	 * Get the RPC header with authorization.
 	 */
 kerbauth:
-	verf_str = auth_str = (char *)0;
+	verf_str = auth_str = NULL;
 	if (nmp->nm_flag & NFSMNT_KERB) {
 		verf_str = nickv;
 		verf_len = sizeof (nickv);
@@ -1140,7 +1140,7 @@ tryagain:
 		else if ((nmp->nm_flag & NFSMNT_KERB) && *tl++ == rpc_autherr) {
 			if (!failed_auth) {
 				failed_auth++;
-				mheadend->m_next = (struct mbuf *)0;
+				mheadend->m_next = NULL;
 				m_freem(mrep);
 				m_freem(rep->r_mreq);
 				goto kerbauth;
@@ -1434,11 +1434,10 @@ nfs_timer(void *arg /* never used */)
 		    nmp->nm_sent < nmp->nm_cwnd) &&
 		   (m = m_copym(rep->r_mreq, 0, M_COPYALL, MB_DONTWAIT))){
 			if ((nmp->nm_flag & NFSMNT_NOCONN) == 0)
-			    error = so_pru_send(so, 0, m, (struct sockaddr *)0,
-				     (struct mbuf *)0, td);
+			    error = so_pru_send(so, 0, m, NULL, NULL, td);
 			else
 			    error = so_pru_send(so, 0, m, nmp->nm_nam,
-			        (struct mbuf *)0, td);
+			        NULL, td);
 			if (error) {
 				if (NFSIGNORE_SOERROR(nmp->nm_soflags, error))
 					so->so_error = 0;
@@ -2240,12 +2239,12 @@ nfsrv_getstream(struct nfssvc_sock *slp, int waitflag, int *countp)
 	    recm = NULL;
 	    if (slp->ns_cc == slp->ns_reclen) {
 		recm = slp->ns_raw;
-		slp->ns_raw = slp->ns_rawend = (struct mbuf *)0;
+		slp->ns_raw = slp->ns_rawend = NULL;
 		slp->ns_cc = slp->ns_reclen = 0;
 	    } else if (slp->ns_cc > slp->ns_reclen) {
 		len = 0;
 		m = slp->ns_raw;
-		om = (struct mbuf *)0;
+		om = NULL;
 
 		while (len < slp->ns_reclen) {
 			if ((len + m->m_len) > slp->ns_reclen) {
@@ -2268,7 +2267,7 @@ nfsrv_getstream(struct nfssvc_sock *slp, int waitflag, int *countp)
 				len += m->m_len;
 				m = m->m_next;
 				recm = slp->ns_raw;
-				om->m_next = (struct mbuf *)0;
+				om->m_next = NULL;
 			} else {
 				om = m;
 				len += m->m_len;
@@ -2297,13 +2296,13 @@ nfsrv_getstream(struct nfssvc_sock *slp, int waitflag, int *countp)
 		    m_freem(slp->ns_frag);
 		} else {
 		    nfs_realign(&slp->ns_frag, 10 * NFSX_UNSIGNED);
-		    rec->nr_address = (struct sockaddr *)0;
+		    rec->nr_address = NULL;
 		    rec->nr_packet = slp->ns_frag;
 		    STAILQ_INSERT_TAIL(&slp->ns_rec, rec, nr_link);
 		    ++slp->ns_numrec;
 		    ++*countp;
 		}
-		slp->ns_frag = (struct mbuf *)0;
+		slp->ns_frag = NULL;
 	    }
 	}
 }
diff --git a/sys/vfs/nfs/nfs_subs.c b/sys/vfs/nfs/nfs_subs.c
index 5c65067..8dce3fa 100644
--- a/sys/vfs/nfs/nfs_subs.c
+++ b/sys/vfs/nfs/nfs_subs.c
@@ -722,7 +722,7 @@ nfsm_rpchead(struct ucred *cr, int nmflag, int procid, int auth_type,
 	}
 	mb->m_next = mrest;
 	mreq->m_pkthdr.len = authsiz + 10 * NFSX_UNSIGNED + mrest_len;
-	mreq->m_pkthdr.rcvif = (struct ifnet *)0;
+	mreq->m_pkthdr.rcvif = NULL;
 	*mbp = mb;
 	return (mreq);
 }
@@ -1058,7 +1058,7 @@ nfs_init(struct vfsconf *vfsp)
 	/* Ensure async daemons disabled */
 	for (i = 0; i < NFS_MAXASYNCDAEMON; i++) {
 		nfs_iodwant[i] = NULL;
-		nfs_iodmount[i] = (struct nfsmount *)0;
+		nfs_iodmount[i] = NULL;
 	}
 	nfs_nhinit();			/* Init the nfsnode table */
 #ifndef NFS_NOSERVER
@@ -1662,7 +1662,7 @@ nfsm_adj(struct mbuf *mp, int len, int nul)
 	m = mp;
 	for (;;) {
 		count += m->m_len;
-		if (m->m_next == (struct mbuf *)0)
+		if (m->m_next == NULL)
 			break;
 		m = m->m_next;
 	}
@@ -1949,14 +1949,14 @@ nfs_getcookie(struct nfsnode *np, off_t off, int add)
 			dp->ndm_eocookie = 0;
 			LIST_INSERT_HEAD(&np->n_cookies, dp, ndm_list);
 		} else
-			return ((nfsuint64 *)0);
+			return (NULL);
 	}
 	while (pos >= NFSNUMCOOKIES) {
 		pos -= NFSNUMCOOKIES;
 		if (dp->ndm_list.le_next) {
 			if (!add && dp->ndm_eocookie < NFSNUMCOOKIES &&
 				pos >= dp->ndm_eocookie)
-				return ((nfsuint64 *)0);
+				return (NULL);
 			dp = dp->ndm_list.le_next;
 		} else if (add) {
 			MALLOC(dp2, struct nfsdmap *, sizeof (struct nfsdmap),
@@ -1965,13 +1965,13 @@ nfs_getcookie(struct nfsnode *np, off_t off, int add)
 			LIST_INSERT_AFTER(dp, dp2, ndm_list);
 			dp = dp2;
 		} else
-			return ((nfsuint64 *)0);
+			return (NULL);
 	}
 	if (pos >= dp->ndm_eocookie) {
 		if (add)
 			dp->ndm_eocookie = pos + 1;
 		else
-			return ((nfsuint64 *)0);
+			return (NULL);
 	}
 	return (&dp->ndm_cookies[pos]);
 }
diff --git a/sys/vfs/nfs/nfs_syscalls.c b/sys/vfs/nfs/nfs_syscalls.c
index ef361d2..e1c913e 100644
--- a/sys/vfs/nfs/nfs_syscalls.c
+++ b/sys/vfs/nfs/nfs_syscalls.c
@@ -205,7 +205,7 @@ sys_nfssvc(struct nfssvc_args *uap)
 		 * Get the client address for connected sockets.
 		 */
 		if (nfsdarg.name == NULL || nfsdarg.namelen == 0)
-			nam = (struct sockaddr *)0;
+			nam = NULL;
 		else {
 			error = getsockaddr(&nam, nfsdarg.name,
 					    nfsdarg.namelen);
@@ -250,12 +250,12 @@ sys_nfssvc(struct nfssvc_args *uap)
 				   kmalloc(sizeof (struct nfsuid), M_NFSUID,
 					M_WAITOK);
 			    } else
-				nuidp = (struct nfsuid *)0;
+				nuidp = NULL;
 			    if ((slp->ns_flag & SLP_VALID) == 0) {
 				if (nuidp)
 				    kfree((caddr_t)nuidp, M_NFSUID);
 			    } else {
-				if (nuidp == (struct nfsuid *)0) {
+				if (nuidp == NULL) {
 				    nuidp = TAILQ_FIRST(&slp->ns_uidlruhead);
 				    LIST_REMOVE(nuidp, nu_hash);
 				    TAILQ_REMOVE(&slp->ns_uidlruhead, nuidp,
@@ -328,7 +328,7 @@ nfssvc_addsock(struct file *fp, struct sockaddr *mynam, struct thread *td)
 
 	so = (struct socket *)fp->f_data;
 #if 0
-	tslp = (struct nfssvc_sock *)0;
+	tslp = NULL;
 	/*
 	 * Add it to the list, as required.
 	 */
@@ -441,7 +441,7 @@ nfssvc_nfsd(struct nfsd_srvargs *nsd, caddr_t argp, struct thread *td)
 	cacherep = RC_DOIT;
 	writes_todo = 0;
 #endif
-	if (nfsd == (struct nfsd *)0) {
+	if (nfsd == NULL) {
 		nsd->nsd_nfsd = nfsd = (struct nfsd *)
 			kmalloc(sizeof (struct nfsd), M_NFSD, M_WAITOK|M_ZERO);
 		crit_enter();
@@ -479,7 +479,7 @@ nfssvc_nfsd(struct nfsd_srvargs *nsd, caddr_t argp, struct thread *td)
 				if (slp == 0)
 					nfsd_head_flag &= ~NFSD_CHECKSLP;
 			}
-			if ((slp = nfsd->nfsd_slp) == (struct nfssvc_sock *)0)
+			if ((slp = nfsd->nfsd_slp) == NULL)
 				continue;
 			if (slp->ns_flag & SLP_VALID) {
 				if (slp->ns_flag & SLP_DISCONN)
@@ -511,7 +511,7 @@ nfssvc_nfsd(struct nfsd_srvargs *nsd, caddr_t argp, struct thread *td)
 				kfree((caddr_t)nd, M_NFSRVDESC);
 				nd = NULL;
 			}
-			nfsd->nfsd_slp = (struct nfssvc_sock *)0;
+			nfsd->nfsd_slp = NULL;
 			nfsd->nfsd_flag &= ~NFSD_REQINPROG;
 			nfsrv_slpderef(slp);
 			continue;
@@ -603,7 +603,7 @@ nfssvc_nfsd(struct nfsd_srvargs *nsd, caddr_t argp, struct thread *td)
 			}
 			nfsstats.srvrpccnt[nd->nd_procnum]++;
 			nfsrv_updatecache(nd, TRUE, mreq);
-			nd->nd_mrep = (struct mbuf *)0;
+			nd->nd_mrep = NULL;
 		    case RC_REPLY:
 			m = mreq;
 			siz = 0;
@@ -617,7 +617,7 @@ nfssvc_nfsd(struct nfsd_srvargs *nsd, caddr_t argp, struct thread *td)
 			}
 			m = mreq;
 			m->m_pkthdr.len = siz;
-			m->m_pkthdr.rcvif = (struct ifnet *)0;
+			m->m_pkthdr.rcvif = NULL;
 			/*
 			 * For stream protocols, prepend a Sun RPC
 			 * Record Mark.
@@ -691,7 +691,7 @@ done:
 	TAILQ_REMOVE(&nfsd_head, nfsd, nfsd_chain);
 	crit_exit();
 	kfree((caddr_t)nfsd, M_NFSD);
-	nsd->nsd_nfsd = (struct nfsd *)0;
+	nsd->nsd_nfsd = NULL;
 	if (--nfs_numnfsd == 0)
 		nfsrv_init(TRUE);	/* Reinitialize everything */
 	return (error);
@@ -716,7 +716,7 @@ nfsrv_zapsock(struct nfssvc_sock *slp)
 	slp->ns_flag &= ~SLP_ALLFLAGS;
 	fp = slp->ns_fp;
 	if (fp) {
-		slp->ns_fp = (struct file *)0;
+		slp->ns_fp = NULL;
 		so = slp->ns_so;
 		so->so_rcv.ssb_flags &= ~SSB_UPCALL;
 		so->so_upcall = NULL;
diff --git a/sys/vfs/nfs/nfs_vfsops.c b/sys/vfs/nfs/nfs_vfsops.c
index ed7528c..4a05d64 100644
--- a/sys/vfs/nfs/nfs_vfsops.c
+++ b/sys/vfs/nfs/nfs_vfsops.c
@@ -306,7 +306,7 @@ nfs_statfs(struct mount *mp, struct statfs *sbp, struct ucred *cred)
 	u_quad_t tquad;
 
 #ifndef nolint
-	sfp = (struct nfs_statfs *)0;
+	sfp = NULL;
 #endif
 	error = nfs_nget(mp, (nfsfh_t *)nmp->nm_fh, nmp->nm_fhsize, &np);
 	if (error)
@@ -777,7 +777,7 @@ nfs_decode_args(struct nfsmount *nmp, struct nfs_args *argp)
 	if (nmp->nm_so && adjsock) {
 		nfs_safedisconnect(nmp);
 		if (nmp->nm_sotype == SOCK_DGRAM)
-			while (nfs_connect(nmp, (struct nfsreq *)0)) {
+			while (nfs_connect(nmp, NULL)) {
 				kprintf("nfs_args: retrying connect\n");
 				(void) tsleep((caddr_t)&lbolt, 0, "nfscon", 0);
 			}
@@ -943,7 +943,7 @@ mountnfs(struct nfs_args *argp, struct mount *mp, struct sockaddr *nam,
 	 * the first request, in case the server is not responding.
 	 */
 	if (nmp->nm_sotype == SOCK_DGRAM &&
-		(error = nfs_connect(nmp, (struct nfsreq *)0)))
+		(error = nfs_connect(nmp, NULL)))
 		goto bad;
 
 	/*
